package com.casic.dcms.view.upload;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;
import android.view.View;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.core.content.ContextCompat;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityBusinessCaseBinding;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.utils.DialogHelper;
import com.casic.dcms.utils.PictureSelectorHelper;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.callback.ISelectorListener;
import com.casic.dcms.view.BigImageActivity;
import com.casic.dcms.view.map.ArcGISMapActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.casic.dcms.vm.UploadViewModel;
import com.gyf.immersionbar.ImmersionBar;
import com.luck.picture.lib.entity.LocalMedia;
import com.pengxh.androidx.lite.adapter.EditableImageAdapter;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.hub.ContextHub;
import com.pengxh.androidx.lite.hub.IntHub;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.utils.ImmerseStatusBarManager;
import com.pengxh.androidx.lite.vm.LoadState;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class BusinessCaseActivity extends AndroidxBaseActivity<ActivityBusinessCaseBinding> {

    private final Context context = BusinessCaseActivity.this;
    private final ArrayList<String> realPaths = new ArrayList<>();//真实图片路径
    private final List<String> imageList = new ArrayList<>();//上传到服务器的数据集
    private UploadViewModel uploadViewModel;
    private CaseViewModel caseViewModel;
    private EditableImageAdapter imageAdapter;
    private String gridId, shopID;

    private final ActivityResultLauncher<Intent> packageCaseLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            if (result.getResultCode() == Activity.RESULT_OK) {
                Intent data = result.getData();
                if (data == null) {
                    return;
                }
                double longitude = data.getDoubleExtra("longitude", 0);
                double latitude = data.getDoubleExtra("latitude", 0);
                gridId = data.getStringExtra("gridId");
                String community = data.getStringExtra("community");
                String shopName = data.getStringExtra("shopName");
                shopID = data.getStringExtra("shopID");

                viewBinding.longitudeView.setText(String.valueOf(longitude));
                viewBinding.latitudeView.setText(String.valueOf(latitude));
                viewBinding.communityNameView.setText(community);
                viewBinding.shopView.setText(shopName);
                viewBinding.shopView.setTextColor(ContextCompat.getColor(context, R.color.mainTextColor));
            }
        }
    });

    @Override
    protected void setupTopBarLayout() {
        ImmerseStatusBarManager.setColor(this, IntHub.convertColor(this, R.color.white));
        ImmersionBar.with(this).statusBarDarkFont(true).init();

        viewBinding.titleBarLayout.titleView.setText("三包上报");
        viewBinding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        caseViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    DialogHelper.showLoadingDialog(context, "案卷提交中，请稍后...");
                } else if (loadState == LoadState.Success) {
                    DialogHelper.dismissLoadingDialog();
                    finish();
                } else {
                    StringHub.show(context, "提交失败，请重试");
                    DialogHelper.dismissLoadingDialog();
                }
            }
        });
    }

    @Override
    public void initData() {
        uploadViewModel = new ViewModelProvider(this).get(UploadViewModel.class);
        uploadViewModel.imageModel.observe(this, new Observer<ActionResultBean>() {
            @Override
            public void onChanged(ActionResultBean resultBean) {
                if (resultBean.getCode() == 200) {
                    if (imageAdapter.getItemCount() <= 4) {
                        String url = resultBean.getData();
                        imageList.add(url);
                        realPaths.add(StringHelper.appendCompleteURL(url));
                        imageAdapter.setupImage(realPaths);
                    } else {
                        StringHub.show(context, "最多只能上传3张图片");
                    }
                }
            }
        });

        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);

        imageAdapter = new EditableImageAdapter(this, 3, 13);
        viewBinding.addImageRecyclerView.setAdapter(imageAdapter);
    }

    @Override
    public void initEvent() {
        viewBinding.shopLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(context, ArcGISMapActivity.class);
                intent.putExtra("type", "三包上报");
                packageCaseLauncher.launch(intent);
            }
        });

        /**
         * 图片九宫格事件处理
         * */
        imageAdapter.setOnItemClickListener(new EditableImageAdapter.OnItemClickListener() {
            @Override
            public void onAddImageClick() {
                PictureSelectorHelper.selectPicture(context, new ISelectorListener() {
                    @Override
                    public void onSuccess(ArrayList<LocalMedia> result) {
                        if (result.size() == 1) {
                            uploadViewModel.uploadImage(new File(result.get(0).getRealPath()));
                        } else {
                            for (LocalMedia localMedia : result) {
                                uploadViewModel.uploadImage(new File(localMedia.getRealPath()));
                            }
                        }
                    }
                });
            }

            @Override
            public void onItemClick(int position) {
                if (realPaths.get(position).isEmpty()) {
                    StringHub.show(context, "图片加载失败，无法查看大图");
                } else {
                    ContextHub.navigatePageTo(context, BigImageActivity.class, position, realPaths);
                }
            }

            @Override
            public void onItemLongClick(View view, int position) {
                imageList.remove(position);
                imageAdapter.deleteImage(position);
            }
        });

        viewBinding.submitButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                submitCase();
            }
        });
    }

    /**
     * 案卷提交
     */
    private void submitCase() {
        String longitude = viewBinding.longitudeView.getText().toString();
        String latitude = viewBinding.latitudeView.getText().toString();
        if (longitude.equals("0") || latitude.equals("0") || TextUtils.isEmpty(longitude) || TextUtils.isEmpty(latitude)) {
            StringHub.show(this, "经纬度异常，请重新选择位置");
            return;
        }
        String shopKeeper = viewBinding.shopKeeperView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(shopKeeper)) {
            StringHub.show(this, "店主名还未填写");
            return;
        }
        String phoneNumber = viewBinding.phoneNumberView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(phoneNumber)) {
            StringHub.show(this, "电话号码还未填写");
            return;
        }
        if (StringHub.isPhoneNumber(phoneNumber)) {
            String fieldIntro = viewBinding.caseLocationView.getText().toString().trim().replace(" ", "");
            if (TextUtils.isEmpty(fieldIntro)) {
                StringHub.show(this, "案卷地点还未填写");
                return;
            }
            String description = viewBinding.caseDetailEditView.getText().toString().trim().replace(" ", "");
            if (TextUtils.isEmpty(description)) {
                StringHub.show(this, "案卷情况还未填写");
                return;
            }
            caseViewModel.submitShopCase("0", "0", longitude, latitude,
                    "2", "1",
                    gridId.substring(0, 6),
                    gridId.substring(0, 9),
                    gridId.substring(0, 12),
                    gridId, description, fieldIntro,
                    StringHelper.reformatURL(imageList),
                    0, 0, shopID, shopKeeper, phoneNumber);
        } else {
            StringHub.show(this, "电话号码格式不对");
        }
    }
}
